package edu.nps.moves.dis7.enumerations;

import java.nio.ByteBuffer;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import edu.nps.moves.dis7.pdus.*;

/**
 * Generated from XML, SISO-REF-010-v28, 2020-05-07<br>
 * UID 309 marshal size 8<br>
 * ExplosiveMaterialGroups
 */
public enum ExplosiveMaterialGroups 
{
    /** General */
    GENERAL (0, "General"),
    /** Liquid - Aviation/Missile Fuels */
    LIQUID_AVIATION_MISSILE_FUELS (1, "Liquid - Aviation/Missile Fuels"),
    /** Liquid - Other Fuels */
    LIQUID_OTHER_FUELS (2, "Liquid - Other Fuels"),
    /** Liquid Explosive Material */
    LIQUID_EXPLOSIVE_MATERIAL (3, "Liquid Explosive Material"),
    /** Solid */
    SOLID (4, "Solid"),
    /** Gaseous */
    GASEOUS (5, "Gaseous"),
    /** Dust Material */
    DUST_MATERIAL (6, "Dust Material");

    private int value;
    private final String description;

    ExplosiveMaterialGroups(int value, String description)
    {
        this.value = value;
        this.description = description;
    }

    public int getValue()
    {
        return value;
    }

    public String getDescription()
    {
        return description;
    }
    
    public static int getEnumBitWidth()
    {
      return 8;
    }

    public static ExplosiveMaterialGroups getEnumForValue(int i)
    {
       for(ExplosiveMaterialGroups val: ExplosiveMaterialGroups.values()) {
          if(val.getValue()==i)
              return val;
       }
       System.err.println("No enumeration found for value " + i + " of enumeration ExplosiveMaterialGroups");
       return null;
    }


    public void marshal(DataOutputStream dos) throws IOException
    {
        dos.writeByte(getValue());
    }
    
    public void marshal(ByteBuffer byteBuffer) throws Exception
    {
        byteBuffer.put((byte)getValue());
    }

    public static ExplosiveMaterialGroups unmarshalEnum (DataInputStream dis) throws Exception
    {
       /* try {
            value = dis.readUnsignedByte();
        }
        catch(IOException ex) {
            showError(ex);
        } */
        
        return getEnumForValue(dis.readByte());
    } 

    public static ExplosiveMaterialGroups unmarshalEnum(ByteBuffer byteBuffer) throws Exception
    {
        /*
        try {
            value = (int)byteBuffer.get();
        }
        catch(Exception ex) {
            showError(ex);
        }
        */
        return getEnumForValue(byteBuffer.get());
    }

  /**
   * Returns size of this serialized (marshalled) object in bytes
   * See <a href="https://en.wikipedia.org/wiki/Marshalling_(computer_science)" target="_blank">https://en.wikipedia.org/wiki/Marshalling_(computer_science)</a>
   * @return serialized size in bytes
   */
    public int getMarshalledSize()
    {
        return 1; // 8 bits
    }
    
  /**
   * Provide simple identifier
   * @return ID number and name
   */
    @Override
    public String toString()
    {
        return "ExplosiveMaterialGroups " + getValue() + " " + name(); 
    }
}
