package edu.nps.moves.dis7.enumerations;

import java.nio.ByteBuffer;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import edu.nps.moves.dis7.pdus.*;

/**
 * Generated from XML, SISO-REF-010-v28, 2020-05-07<br>
 * UID 184 marshal size 8<br>
 * IntercomControlDestinationLineStateCommand
 */
public enum IntercomControlDestinationLineStateCommand 
{
    /** None */
    NONE (0, "None"),
    /** Set Line State - Transmitting */
    SET_LINE_STATE_TRANSMITTING (1, "Set Line State - Transmitting"),
    /** Set Line State - Not Transmitting */
    SET_LINE_STATE_NOT_TRANSMITTING (2, "Set Line State - Not Transmitting"),
    /** Return to Local Line State Control */
    RETURN_TO_LOCAL_LINE_STATE_CONTROL (3, "Return to Local Line State Control");

    private int value;
    private final String description;

    IntercomControlDestinationLineStateCommand(int value, String description)
    {
        this.value = value;
        this.description = description;
    }

    public int getValue()
    {
        return value;
    }

    public String getDescription()
    {
        return description;
    }
    
    public static int getEnumBitWidth()
    {
      return 8;
    }

    public static IntercomControlDestinationLineStateCommand getEnumForValue(int i)
    {
       for(IntercomControlDestinationLineStateCommand val: IntercomControlDestinationLineStateCommand.values()) {
          if(val.getValue()==i)
              return val;
       }
       System.err.println("No enumeration found for value " + i + " of enumeration IntercomControlDestinationLineStateCommand");
       return null;
    }


    public void marshal(DataOutputStream dos) throws IOException
    {
        dos.writeByte(getValue());
    }
    
    public void marshal(ByteBuffer byteBuffer) throws Exception
    {
        byteBuffer.put((byte)getValue());
    }

    public static IntercomControlDestinationLineStateCommand unmarshalEnum (DataInputStream dis) throws Exception
    {
       /* try {
            value = dis.readUnsignedByte();
        }
        catch(IOException ex) {
            showError(ex);
        } */
        
        return getEnumForValue(dis.readByte());
    } 

    public static IntercomControlDestinationLineStateCommand unmarshalEnum(ByteBuffer byteBuffer) throws Exception
    {
        /*
        try {
            value = (int)byteBuffer.get();
        }
        catch(Exception ex) {
            showError(ex);
        }
        */
        return getEnumForValue(byteBuffer.get());
    }

  /**
   * Returns size of this serialized (marshalled) object in bytes
   * See <a href="https://en.wikipedia.org/wiki/Marshalling_(computer_science)" target="_blank">https://en.wikipedia.org/wiki/Marshalling_(computer_science)</a>
   * @return serialized size in bytes
   */
    public int getMarshalledSize()
    {
        return 1; // 8 bits
    }
    
  /**
   * Provide simple identifier
   * @return ID number and name
   */
    @Override
    public String toString()
    {
        return "IntercomControlDestinationLineStateCommand " + getValue() + " " + name(); 
    }
}
